@echo off

rem     Syntax SENDAFAX (filename) (extension) (number) (sender)

rem     This section will have to be rewritten for your fax software.

rem     It should take a text file and fax it to the given number, setting
rem     the errorlevel if sending fails.  Your fax software may do this with
rem     only one command, mine is particularly messy, and I also include some
rem     special handling for our PABX.

rem     The fax software should be set not to retry.  Retrys are handled by
rem     this batch file without tying up the fax server.

rem     I have drive I: must be mapped to directory containing faxes.


rem     -=-=-=-=-=-=-=- start software specific section -=-=-=-=-=-=-=-

echo.
echo Converting file %1.%2 for %4.
echo.

c:
c:\ql2fax\convert i:%1.%2 /h
if errorlevel 1 c:\ql2fax\convert i:%1.%2 /x /h
if errorlevel 1 goto failure

echo.
echo Sending file %1.%2 to %3 for %4.
echo.

del c:\ql2fax\faxsend.log
h:\errorlen %3

rem If the number is six digits or longer, prepend 0 to get through the PABX.

if not errorlevel 6 goto nozero
c:\ql2fax\qld001 3 /f:i:%1 /fn:0%3
goto wait

:nozero
c:\ql2fax\qld001 3 /f:i:%1 /fn:%3

:wait

rem Wait for a log file to appear, and set errorlevel according to the result.

h:\logmon

rem     -=-=-=-=-=-=-=- end of software specific section -=-=-=-=-=-=-=-


rem     The rest should work for any fax software, providing errorlevel is set.

if not errorlevel 1 goto success
if exist i:%1.bat goto retry1
if exist i:2ndtry\%1.bat goto retry2

rem     This runs if the fax failed and we're not going to retry.

:failure
z:\writelog f:\logs\faxmail.log %4 faxed %2 file to %3 (fail3).
if '%2' == 'CNM' f:\applic\pegasus\pmail -t %4 -f i:%1.%2 -s "fax NOT sent to %3"
if not '%2' == 'CNM' send "%2 file NOT sent to %3" to %4
del i:%1.%2
goto end


rem     One of these runs if the fax failed and we want to retry.

:retry1
z:\writelog f:\logs\faxmail.log %4 faxed %2 file to %3 (fail1).
send "%2 file not sent to %3, will retry." to %4
md i:2ndtry
copy i:%1.bat i:2ndtry
goto end

:retry2
z:\writelog f:\logs\faxmail.log %4 faxed %2 file to %3 (fail2).
send "%2 file not sent to %3, will retry." to %4
md i:3rdtry
copy i:2ndtry\%1.bat i:3rdtry
goto end


rem     This runs if the fax was sent successfully.

:success
z:\writelog f:\logs\faxmail.log %4 faxed %2 file to %3.
if '%2' == 'CNM' f:\applic\pegasus\pmail -t %4 -f i:%1.%2 -s "fax sent to %3"
if not '%2' == 'CNM' send "%2 file sent to %3" to %4
del i:%1.%2

:end
